(function() {
  var Query, copy, dialects, fluid, passthrough_resolver;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  fluid = require('./fluid');
  dialects = require('./dialects');
  module.exports = Query = (function() {
    function Query(opts) {
      this.dialect = opts.dialect || dialects["default"];
      this.resolve = opts.resolver || passthrough_resolver;
      this.s = {};
    }
    Query.prototype.clone = function() {
      var child;
      child = new this.constructor;
      child.dialect = this.dialect;
      child.resolve = this.resolve;
      child.s = copy(this.s);
      return child;
    };
    Query.prototype.visit = fluid(function(fn) {
      if (fn != null) {
        return fn.call(this, this);
      }
    });
    Query.prototype.toSql = function() {
      return this.dialect["render" + this.s.queryType](this.s);
    };
    Query.prototype.execute = function(conn, cb) {
      if (conn['acquire'] != null) {
        return conn.acquire(__bind(function(c) {
          return this.execute(c, cb);
        }, this));
      } else {
        return conn.query(this.toSql(), this.s.parameters, cb);
      }
    };
    Query.prototype.toString = function() {
      return "[Query \"" + (this.toSql().substring(0, 20)) + "\"]";
    };
    return Query;
  })();
  passthrough_resolver = {
    table: function(n) {
      return n;
    },
    field: function(t, n) {
      return n;
    }
  };
  copy = function(thing) {
    var c, k, obj, v;
    if (thing === null) {
      return null;
    } else if (thing.constructor === Array) {
      c = [];
      c.push.apply(c, thing);
      return c;
    } else if ('object' === typeof thing) {
      obj = {};
      for (k in thing) {
        v = thing[k];
        obj[k] = copy(v);
      }
      return obj;
    } else {
      return thing;
    }
  };
}).call(this);
