(function() {
  var SUDQuery, Select, fluid, normalize;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  SUDQuery = require('./sud-query');
  normalize = require('./normalize');
  module.exports = Select = (function() {
    __extends(Select, SUDQuery);
    function Select(table, opts) {
      if (opts == null) {
        opts = {};
      }
      Select.__super__.constructor.call(this, table, opts);
      this.s.queryType = 'Select';
      this.s.order = [];
      this.s.groupings = [];
    }
    Select.prototype.orderBy = fluid(function() {
      var args, orderings, _ref;
      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      orderings = normalize.orderings(args, this.lastTable(), this.dialect.order);
      return (_ref = this.s.order).push.apply(_ref, orderings);
    });
    Select.prototype.groupBy = function() {
      var field, fields, groupings, _ref;
      fields = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      groupings = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = fields.length; _i < _len; _i++) {
          field = fields[_i];
          _results.push(normalize.fieldAndTable({
            table: this.lastTable(),
            field: field
          }));
        }
        return _results;
      }).call(this);
      return (_ref = this.s.groupings).push.apply(_ref, groupings);
    };
    Select.prototype.limit = fluid(function(l) {
      return this.s.limit = l;
    });
    return Select;
  })();
  Select.from = function(tbl, fields, opts) {
    var select, _ref;
    if (tbl.constructor === Select) {
      throw new Error("Inner queries not supported yet");
    }
    if ((fields != null) && ((_ref = fields.constructor) !== String && _ref !== Array)) {
      opts = fields;
      fields = null;
    }
    select = new Select(tbl, opts);
    if (fields != null) {
      switch (fields.constructor) {
        case String:
          select.fields(fields);
          break;
        case Array:
          select.fields.apply(select, fields);
      }
    }
    return select;
  };
}).call(this);
